

import java.io.*;
import java.net.*;
import java.util.*;

public final class OneMeanSonOfABot {

   public static Socket s;
   public static int myPort;
   public static int serverPort;
   public static InputStream is;
   public static OutputStream os;
   public static BufferedReader br;
   public static Robot me;
   public static int capacity;
   public static int load;
   public static int money;
   public static int pickTries;
   public static boolean newPackages = false;
   
   public static char desiredMove;
   public static int badCount;

   public static final void sendMove(char mv, String move) throws Exception {
      desiredMove = mv;
      os.write(move.getBytes());
   }

   public static boolean reachable(Point p) {
      return me.loc.distance(p) < money;
   }
   
   public static void readBoard() throws Exception {
      StringTokenizer st = new StringTokenizer(br.readLine());
      int cols = Integer.parseInt(st.nextToken());
      int rows = Integer.parseInt(st.nextToken());
      new Board(rows, cols);
      for (int i = 0; i < rows; i++) {
         Board.setRow(i, br.readLine());
      }
   }
   
   public static void readConfig() throws Exception {
      StringTokenizer st = new StringTokenizer(br.readLine());
      me = new Robot(st.nextToken());
      capacity = Integer.parseInt(st.nextToken());
      money = Integer.parseInt(st.nextToken());
   }

   public static void readPackages() throws Exception {
      String input = br.readLine();
      StringTokenizer st = new StringTokenizer(input);
      newPackages = st.hasMoreTokens();
      if (newPackages) {
         while (st.hasMoreTokens()) {
            String id = st.nextToken();
            int dx = Integer.parseInt(st.nextToken());
            int dy = Integer.parseInt(st.nextToken());
            int w = Integer.parseInt(st.nextToken());
            Package.reportedPackage(id, dx, dy, w, me.loc);
         }
      }
      for (Iterator i = Package.maybePackages.values().iterator(); i.hasNext(); ) {
         Package p = (Package) i.next();
         if (p.loc.equals(me.loc)) { 
            i.remove();
         }
      }
   }

   public static void readResponse() throws Exception {
      Robot bot = null;
      StringTokenizer st = null;
      int x = 0;
      for (Iterator i = Robot.allRobots.values().iterator(); i.hasNext(); ) {
         ((Robot)i.next()).alive = false;
      }
      try {
         st = new StringTokenizer(br.readLine());
      } catch (Exception ex) {
         //something went horrible wrong, we can't read the last response
         //and our state is completely out of whack, so just die
         sendMove('X', "1 Die\n"); //invalid command should kill me off
         return;
      }
      while (st.hasMoreTokens()) {
         String tok = st.nextToken();
         char ch = tok.charAt(0);
         if (ch == '#') {
            String theBot = tok.substring(1);
            bot = (Robot) Robot.allRobots.get(theBot);
            if (bot == null) {
               bot = new Robot(theBot);
            }
            bot.alive = true;
         }
         else {
            if (bot == me && desiredMove != ch) {
               badCount++;
            }
            else {
               badCount = 0;
            }
            switch (ch) {
               case 'P':
                  bot.pickup(st.nextToken());
                  break;
               case 'D':
                  bot.drop(st.nextToken());
                  break;
               case 'X':
                  x = Integer.parseInt(st.nextToken());
                  break;
               case 'Y':
                  if (bot == me) badCount -= 2;
                  bot.setXY(x, Integer.parseInt(st.nextToken()));
                  break;
               default: //must be a move
                  bot.move(ch);
                  break;
            }
         }
      }
      Robot.cleanUp();
   }

   public static void init() throws Exception {
      os.write("Player\n".getBytes());
      readBoard();
      readConfig();
      readResponse();
   }

   public static Node AStarSearch(Point start, Point goal) {
      PQ open = new PQ();
      Hashtable closed = new Hashtable();
      Node n = new Node(start, null, goal);
      open.add(n);
      Vector v = new Vector();
      while (!open.isEmpty()) {
         n = open.popFirst();
         if (n.equals(goal)) {
            return n;
         }
         v.clear();
         v.add(new Node(n.x - 1, n.y, n, goal));
         v.add(new Node(n.x + 1, n.y, n, goal));
         v.add(new Node(n.x, n.y + 1, n, goal));
         v.add(new Node(n.x, n.y - 1, n, goal));
         for (int i = 0; i < 4; i++) {
            Node np = (Node) v.elementAt(i);
            Node temp = null;
            char ch = Board.getTile(np.x, np.y);
            if (ch == Board.PLAIN || ch == Board.HOME) {
               if ((temp = open.find(np)) != null) {
                  if (temp.g <= np.g) continue;
                  open.remove(temp);
               } else if ((temp = (Node)closed.get(np.toString())) != null) {
                  if (temp.g <= np.g) continue;
                  closed.remove(np.toString());
               }
               open.add(np);
            }
         }
         closed.put(n.toString(), n);
      }
      return null; // if no path found 
   }
   
   public static final char getMoveFromNode(Node n) {
      while (n != null) {
         if (n.prev != null && n.prev.prev == null) {
            char mv = 'N';
            if (n.x == me.loc.x) {
               return n.y > me.loc.y ? 'N' : 'S';
            }
            else {
               return n.x > me.loc.x ? 'E' : 'W';
            }
         }
         n = n.prev;
      }
      return 'X';
   }
   
   //closest package not being held
   public static char moveForNearestPackage() {
      int cost = 1000000;
      Node resultNode = null;
      for (Iterator i = Package.pkgsByLocation.keySet().iterator(); i.hasNext(); ) {
         Point p = (Point) i.next();
         Node n = AStarSearch(me.loc, p);
         if (n != null) {
            if (n.g < cost) {
               cost = n.g;
               resultNode = n;
            }
         }
      }
      return getMoveFromNode(resultNode);
   }
   
   public static final char moveForNearestHome() {
      int cost = 1000000;
      Node resultNode = null;
      for (Iterator i = Board.allHomes.iterator(); i.hasNext(); ) {
         Point p = (Point) i.next();
         Node n = AStarSearch(me.loc, p);
         if (n != null) {
            if (n.g < cost) {
               cost = n.g;
               resultNode = n;
            }
         }
      }
      return getMoveFromNode(resultNode);
   }
   
   public static boolean useMove(char mv) throws Exception {
      if (mv == 'X') return false;
      int myBid = badCount == 0 ? 1 : badCount * 5; 
      if (myBid > money) myBid = money;
      sendMove(mv, myBid + " Move " + mv + "\n");
      money -= myBid;
      return true;
   }
   
   public static boolean moveTowards(Point goal) throws Exception {
      if (goal == null) return false;
      //move towards closest package or base
      //look for shortest path to various homes
      Node n = AStarSearch(me.loc, goal);
      return useMove(getMoveFromNode(n));
   }
   
   public static boolean canDrop() throws Exception {
      //drop the right packages
      String list = me.getDropList();
      if (list.length() > 0) {
         int myBid = closestBot == 1 ? 10 : 1;
         if (myBid > money) myBid = money;
         sendMove('D', myBid + " Drop " + list + "\n");
         money -= myBid;
         return true;
      }
      return false;
   }
   
   public static boolean canPick() throws Exception {
      //pick up some packages
      Iterator i = Package.getPackageList(me.loc);
      int pickCount = 0;
      if (i != null) {
         StringBuffer list = new StringBuffer();
         int desiredLoad = me.load;
         while (i.hasNext()) {
            Package p = (Package)i.next();
            if (p.held) continue; //held by me
            if (p.weight <= (capacity - desiredLoad)) {
               desiredLoad += p.weight;
               list.append(p.id);
               list.append(' ');
               pickCount++;
            }
         }
         if (list.length() > 0) {
            list.append('\n');
            int myBid = badCount == 0 ? 1 : badCount * 5; 
            if (myBid > money) myBid = money;
            sendMove('P', myBid + " Pick " + list);
            money -= myBid;
            return true;
         }
      }
      return false; //no packages I can pick up
   }
   
   public static boolean canDeliver() throws Exception {
      //move towards destination - change to nearest
      return moveTowards(me.closestDestination());
   }
   
   public static final boolean moveToPseudoPackage() throws Exception {
      //move towards destination - change to nearest
      return moveTowards(Package.closestPseudoPackage(me.loc));
   }
   
   public static final void randomMove() throws Exception {
      if (!moveTowards(Board.nextSearch())) {
         sendMove('P', "1 Pick\n");
         money--;
      }
   }
   
   public static int closestBot;
   public static Vector tooClose;
   
   public static void getAdjacentBotList() {
      closestBot = me.closestBot();
      tooClose = Robot.closest;
   }
   
   public static char whichWay(Robot r1, Robot r2) {
      if (r2.loc.x > r1.loc.x) return 'E';
      if (r2.loc.x < r1.loc.x) return 'W';
      if (r2.loc.y < r1.loc.y) return 'S';
      return 'N';
   }
   
   public static boolean killMode = false;

   public static boolean canKill() throws Exception {
      if (closestBot == 1) {
         for (Iterator i = tooClose.iterator(); i.hasNext(); ) {
            Robot r = (Robot) i.next();
            if (Board.getTile(r.loc.x, r.loc.y) == Board.WATER) {
               continue;//not sure why I need to do this, but I do
            }
            char dir = whichWay(me, r);
            int dist = Board.canKill(me.loc, dir);
            if (dist > 0) {
               int bid;
               if (!killMode && dist == 1 && money > 250) {
                  bid = 250; 
               }
               else if (money >= dist * 50) {
                  bid = 50;
               }
               else {
                  bid = money / dist;
               }
               bid = bid > 0 ? bid : 1;
               sendMove(dir, bid + " Move " + dir + "\n");
               money -= bid;
               killMode = true;
               return true;
            }
         }
      }
      killMode = false;
      return false;
   }
   
   public static void move() throws Exception {
      //need a measure of safety, check distance to other bots
      //and alter behavior if we are too close
      getAdjacentBotList(); //setup for mustProtect and canKill
      if (canDrop()) return;
      if (canKill()) return;
      if (canPick()) return; //adjust this so don't get in a pick war if I already have packages
      if (canDeliver()) return;
      if (useMove(moveForNearestPackage())) return;
      //go for the one we can reach fastest 
      if (useMove(moveForNearestHome())) return;
      if (moveTowards(Package.closestHeldPackage(me))) return;
      //no good goal, so see if there are known maybePackages
      if (moveTowards(Package.closestPseudoPackage(me.loc))) return;
      //should never get here in a real game because we should have
      //seen all pacakges picked up and dropped and at least see them
      //in the maybePackages list
      randomMove(); //maintain bitmap
   }

   public static void play() throws Exception {
      int turn = 1;
      while (Robot.allRobots.containsKey(me.id)) {
         newPackages = false;
         readPackages();
         move();
         readResponse();
         if (turn == 1) {
            (new NastyThread(myPort, serverPort)).start();
            turn++;
         }
         Board.mark(me.loc);  //do this here because there is no better place
      }
   }
   
   public static void main(String args[]) {
      try {
         if (args.length != 2) {
            System.err.println("usage error, not enough arguments");
         }
         else {
            serverPort = Integer.parseInt(args[1]);
            s = new Socket(args[0], serverPort);
            myPort = s.getLocalPort();
            is = s.getInputStream();
            os = s.getOutputStream();
            br = new BufferedReader(new InputStreamReader(is));
            init();
            play();
         }
      } catch (Exception ex) {
         try {
            s.close();  //be nice and close socket
         } catch (Exception cex) {
         }
      }
   }

}
