
import java.util.*;

public final class Robot {
   
   public static Hashtable allRobots = new Hashtable();
   
   public String id;
   public Point loc = new Point(0,0);
   public boolean alive = false;
   public Hashtable myPackages = new Hashtable();  //mix of actual and maybe packages
   public int load = 0;
   public int score = 0;
   
   public Robot(String id) {
      this.id = id;
      allRobots.put(id, this);
   }

   public final void move(char dir) {
      switch (dir) {
         case 'N':
            loc.y++;
            break;
         case 'S':
            loc.y--;
            break;
         case 'E':
            loc.x++;
            break;
         case 'W':
            loc.x--;
            break;
      }
   }

   public final void setXY(int x, int y) {
      loc.x = x;
      loc.y = y;
   }

   public final Point closestDestination() {
      int minDist = 2000;  //longest distance between pts on largest board
      Point result = null;
      for (Iterator i = myPackages.values().iterator(); i.hasNext(); ) {
         Package h = (Package) i.next();
         int dist = loc.distance(h.dest);
         if (dist < minDist) {
            result = h.dest;
            minDist = dist;
         }
      }
      return result;
   }

   public static Vector closest = new Vector();

   public final int closestBot() {
      closest.clear();
      int minDist = 2000;  //longest distance between pts on largest board
      for (Iterator i = allRobots.values().iterator(); i.hasNext(); ) {
         Robot r = (Robot) i.next();
         if (r == this) continue;
         int dist = loc.distance(r.loc);
         if (dist < minDist) {
            if (dist == 1) closest.add(r);
            minDist = dist;
         }
      }
      return minDist;
   }

   public final String getDropList() {
      StringBuffer result = new StringBuffer();
      for (Iterator i = myPackages.values().iterator(); i.hasNext(); ) {
         Package h = (Package) i.next();
         if (loc.equals(h.dest)) {
            result.append(h.id);
            result.append(' ');
         }
      }
      return result.toString();
   }

   public final void pickup(String pkg) {
      Package p = (Package) Package.freePackages.get(pkg);
      if (p == null) {  //didn't pick up a known free package
         p = Package.maybePackage(pkg, loc); //this package will change loc w/ the robot
      }
      else {
         p.untrack();
      }
      load += p.weight;
      p.held = true;
      myPackages.put(pkg, p);
   }

   public final void drop(String pkg) {
      Point pt = new Point(loc.x, loc.y);
      Package p = (Package) Package.heldPackages.remove(pkg); //dropped so no longer held
      if (p == null) {
         p = Package.maybePackage(pkg, pt); 
      }
      else {
         if (loc.equals(p.dest)) { //if we know the dest, we know the weight
            score += p.weight;
            p.disappear();
         }
         else {
            p.loc = pt; //update location since we were not tracking
            p.track();
         }
      }
      p.held = false;
      load -= p.weight;
      myPackages.remove(pkg);
   }
   
   public static void cleanUp() {
      for (Iterator i = allRobots.keySet().iterator(); i.hasNext(); ) {
         Robot r = (Robot) allRobots.get(i.next());
         if (!r.alive) {
            for (Iterator j = r.myPackages.keySet().iterator(); j.hasNext(); ) {
               Package p = (Package) r.myPackages.get(j.next());
               p.disappear();  //disappear the package
               j.remove();
            }
            i.remove();
         }
      }
   }

}